=== debian/changelog ===
pushover (0.0.5+git20180420-2ubuntu1) cosmic; urgency=medium

  * debian/patches/library-link-order.patch: Ensure libraries linked are
    listed after objects using them.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 22 Aug 2018 16:12:10 -0700

pushover (0.0.5+git20180420-2) unstable; urgency=medium

  * debian/pushover.6: updated. (Closes: #896984)
  * Added to Debian Games Team.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 02 May 2018 15:08:23 +0200

pushover (0.0.5+git20180420-1) unstable; urgency=medium

  * Initial release. (Closes: #505966)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 20 Apr 2018 12:23:21 +0200
