=== debian/changelog ===
pushover (0.0.5+git20180909-4build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 06 Feb 2020 11:07:00 +0000

pushover (0.0.5+git20180909-4) unstable; urgency=medium

  * Bump standards version to 4.4.1.
  * Add Vcs fields.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 14 Nov 2019 13:27:08 +0100

pushover (0.0.5+git20180909-3) unstable; urgency=medium

  * Add missing Breaks+Replaces. (Closes: #908675)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 12 Sep 2018 16:28:17 +0200

pushover (0.0.5+git20180909-2) unstable; urgency=medium

  * Add missing Depends fonts-freefont-ttf. (Closes: #908517)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Tue, 11 Sep 2018 16:58:43 +0200

pushover (0.0.5+git20180909-1) unstable; urgency=medium

  * New upstream version. (Closes: #897905, #906998)
  * Bump standards version to 4.2.1.
  * debian/control: fix typo in long description.
  * debian/pushover.desktop: dropped, included upstream.
  * Put music into a new package, pushover-data.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sun, 09 Sep 2018 13:55:07 +0200
