=== debian/watch ===
version=4
# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/pushover/pushover.github.io/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
