=== src/doc/Makefile ===
.PHONY: default
default:
	$(MAKE) -C ../..
