=== debian/changelog ===
pushover (1.1-6) unstable; urgency=medium

  * Team upload.
  * Fix watch file (Closes: #1089926)

 -- Patrice Duroux <patrice.duroux@gmail.com>  Sat, 14 Dec 2024 17:18:05 +0100

pushover (1.1-5) unstable; urgency=medium

  * Fix FTBFS with GCC-14 (Closes: #1075402)

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #1063459)
    + libsdl2-image-dev is used for the build architecture.
    + cross.patch: Distinguish build and host compiler flags.

 -- Alexandre Detiste <tchet@debian.org>  Sat, 03 Aug 2024 16:55:04 +0200

pushover (1.1-4) unstable; urgency=medium

  * Team upload.
  * Drop myself from uploaders
  * Update my name
  * Bump standards version to 4.7.0.

 -- Alex Myczko <tar@debian.org>  Thu, 18 Jul 2024 16:57:05 +0000

pushover (1.1-3) unstable; urgency=medium

  * source upload to allow migration of NEW packages
  * build with Lua5.4 instead of Lua5.2
  * rename project on Salsa 'pushover' -> 'domino-chain'

 -- Alexandre Detiste <tchet@debian.org>  Sat, 16 Dec 2023 14:25:10 +0100

pushover (1.1-2) unstable; urgency=low

  * rename binary packages as requested by upstream (Closes: #960382)
  * provide an additional transitional package for existing users
  * bump Standards-Version, no further change needed
  * add copyright information for vendored code

 -- Alexandre Detiste <tchet@debian.org>  Fri, 01 Dec 2023 18:16:15 +0100

pushover (1.1-1) unstable; urgency=low

  * New upstream version 1.1
  * build with SDL2 (Closes: #1038547)
  * switch to debhelper 13
  * remove patch applied upstream
  * always read assests from system datadir (Closes: #996484)
  * define R³: no
  * remove Debian manpage stub, upstream provide a better one

  -> in the very next upload the game will be renamed 'Domino Chain'
     as requested by upstream (#960382)

  [ Debian Janitor ]
  * Apply multi-arch hints.
    + pushover-data: Add Multi-Arch: foreign.

 -- Alexandre Detiste <tchet@debian.org>  Fri, 01 Dec 2023 00:57:58 +0100
