=== debian/control ===
Source: pushover
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Alexandre Detiste <tchet@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 pkgconf,
 imagemagick,
 fonts-freefont-ttf,
 povray,
 liblua5.4-dev,
 libfribidi-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-system-dev,
 libsdl2-image-dev:native,
 libsdl2-mixer-dev,
 libsdl2-ttf-dev,
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/games-team/domino-chain
Vcs-Git: https://salsa.debian.org/games-team/domino-chain.git
Homepage: https://domino-chain.gitlab.io/
Rules-Requires-Root: no

Package: domino-chain
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-freefont-ttf
Recommends: domino-chain-music
Breaks: pushover (<< 1.1-2~), pushover-data (<< 1.1-2~)
Replaces: pushover (<< 1.1-2~), pushover-data (<< 1.1-2~)
Description: Fun puzzle game with dominos
 This is a remake of a fun puzzle game originally published by Ocean in 1992.
 In this game you control an ant that can walk along platforms that are
 connected with ladders. On those platforms are dominos that need to fall
 according to some rules.
 .
  - All dominos must fall and none must crash into another
  - One special domino must fall as last domino and that domino triggers
    the exit door to open when you enter the exit door the level has been
    completed
  - You may rearrange as many dominos as you want, except for the trigger.
    You may not place dominos in front of the doors, except for the vanishing
    domino.
  - You may push once to start a chain reaction with the dominos leading to
    the fall of all of them
  - All this has to be done within a time limit (which is normally generous)
  - There are 10 different dominos that behave differently when pushed, some
    fall, some not, some wait a bit before they fall, some raise, some toppler
    until they meet an obstacle
  - There is a help in the game and introductory levels that show how all the
    dominos work

Package: domino-chain-music
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Fun puzzle game with dominos, music files
 This is a remake of a fun puzzle game originally published by Ocean in 1992.
 In this game you control an ant that can walk along platforms that are
 connected with ladders. On those platforms are dominos that need to fall
 according to some rules.
 .
 This package contains the optional background music.

Package: pushover
Architecture: all
Depends: domino-chain, ${misc:Depends}
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.
