=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildtools.mk
include /usr/share/dpkg/buildflags.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	$(MAKE) BINDIR=/usr/games DATADIR=/usr/share/games CXX=$(CXX) CXXFLAGS='$(CPPFLAGS) $(CXXFLAGS) -Wall -Wextra -g -O2 -std=c++17' LDFLAGS='$(LDFLAGS)' PKG_CONFIG=$(PKG_CONFIG) PKG_LUA=lua-5.4 CXXFLAGS_NATIVE='$(CPPFLAGS_FOR_BUILD) $(CXXFLAGS_FOR_BUILD) -Wall -Wextra -g -O2 -std=c++17' LDFLAGS_NATIVE='$(LDFLAGS_FOR_BUILD)'

override_dh_auto_test:
	echo "checks needs portable_datadir and are disabled"

override_dh_auto_install:
	$(MAKE) install BINDIR=$(CURDIR)/debian/domino-chain/usr/games DATADIR=$(CURDIR)/debian/tmp/usr/share
