=== debian/watch ===
version=4
opts=searchmode=plain \
https://gitlab.com/domino-chain/domino-chain.gitlab.io/-/tags \
  archive/[^/]+/domino-chain.gitlab.io@ANY_VERSION@@ARCHIVE_EXT@
